/********************************************************************************
 * Copyright (c) 2022-2024 Bayerische Motoren Werke Aktiengesellschaft (BMW AG)
 *
 * This program and the accompanying materials are made available under the
 * terms of the Eclipse Public License 2.0 which is available at
 * http://www.eclipse.org/legal/epl-2.0.
 *
 * SPDX-License-Identifier: EPL-2.0
 ********************************************************************************/
//! @file driverInterface.h
#pragma once

#include "include/signal/driverInput.h"
#include "include/signal/driverOutput.h"

namespace scm::driver
{
//! @brief Interface class for the driver (previously named AlgorithmScmMonolithisch). */
class Interface
{
public:
  //! @brief Retrieve (SCM-) driver output values generated by the trigger method. */
  //! @param driverInput DriverInput
  //! @param time
  //! @return driver output signal
  virtual scm::signal::DriverOutput Trigger(const scm::signal::DriverInput& driverInput, units::time::millisecond_t time) = 0;
  virtual ~Interface() = default;
};
}  // namespace scm::driver